#pragma ident  "@(#)enum.c	1.0 93/10/26"

/******************************************************************************/
/*                                                                            */
/*  (c) Copyright Hewlett-Packard Company, 1993, Fort Collins, Colorado       */
/*                                                                            */
/*  (C) COPYRIGHT International Business Machines Corp. 1993                  */
/*                                                                            */
/*                            All Rights Reserved                             */
/*                                                                            */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,          */
/*  provided that the above copyright notices appear in all copies and that   */
/*  both the copyright notices and this permission notice appear in           */
/*  supporting documentation, and that the name of Hewlett-Packard not be     */
/*  used in advertising or publicity pertaining to distribution of the        */
/*  software without specific, written prior permission.                      */
/*                                                                            */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS         */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/*  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable for errors contained herein or direct, indirect,      */
/*  special, incidental or consequential damages in connection with the       */
/*  furnishing, performance or use of this software.                          */
/*                                                                            */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THIS MATERIAL        */
/*  "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,        */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND FITNESS FOR A PARTICULAR PURPOSE.                                     */
/*                                                                            */
/******************************************************************************/

#include <X11/PEX5/PEXlib.h>
#include <X11/PEX5/PEXExtlib.h>
#include <misc.h>


/* 
 * PEXlib Enumerations Module:  Extended Enumerations Types
 *
 */

void inquire_test_params(char *test_name, 
			 int  *num_images, 
			 int  *supported_modes, 
			 char *win_title)
    {
    strcpy(test_name, "enum");
    *num_images      = 28;
    *supported_modes = NON_OC_MODE;

    strcpy(win_title, "enum");
    }

Window local_win ;

void misc_setup(Display *dpy, Window window, PEXRenderer renderer,
		int cur_image)
    {
    char * file_name[80] ;
    
    local_win = window ;
    sprintf(file_name,"enum_%d.stderr",cur_image) ; 
    _ibmpex_set_stderr(file_name, "enum");
    }

void execute_test(Display *dpy, XID resourceID, 
	       PEXOCRequestType req_type, int cur_image)
{
    int                 status, enum_types[30] ;
    PEXEnumTypeDesc     *values ;
    unsigned int        *num_values ;
    unsigned long       item_mask ;
    int                 i, j, count ;

    /* setup for PEXGetEnumTypeInfo */
    switch (cur_image)
    {
    case 1:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 1     Extended Enumeration Types \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETEnumType ;
        break ;
    case 2:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 2     Extended Output Commands \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETOC ;
        break ;
    case 3:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 3     Extended PC Attributes \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETPC ;
        break ;
    case 4:
        _ibmpex_stderr_print( "*****************************************\n");
        _ibmpex_stderr_print( " Test 4     Extended Renderer Attributes \n");
        _ibmpex_stderr_print( "*****************************************\n\n");

        enum_types[0] = PEXExtETRA ;
        break ;
    case 5:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 5     Extended Lookup Tables \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETLUT ;
        break ;
    case 6:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 6     Extended ImpDep Constants \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETID ;
        break ;
    case 7:
        _ibmpex_stderr_print( "********************************************\n");
        _ibmpex_stderr_print( " Test 7     Texture Mapping Rendering Order \n");
        _ibmpex_stderr_print( "********************************************\n\n");

        enum_types[0] = PEXExtETTMRenderingOrder ;
        break ;
    case 8:
        _ibmpex_stderr_print( "**********************************************\n");
        _ibmpex_stderr_print( " Test 8     Texture Mapping Coordinate Source\n");
        _ibmpex_stderr_print( "**********************************************\n\n");

        enum_types[0] = PEXExtETTMCoordSource ;
        break ;
    case 9:
        _ibmpex_stderr_print( "*********************************************\n");
        _ibmpex_stderr_print( " Test 9     Texture Mapping Composite Method \n");
        _ibmpex_stderr_print( "*********************************************\n\n");

        enum_types[0] = PEXExtETTMCompositeMethod ;
        break ;
    case 10:
        _ibmpex_stderr_print( "************************************************\n");
        _ibmpex_stderr_print( " Test 10    Texture Mapping Texel Sample Method\n");
        _ibmpex_stderr_print( "************************************************\n\n");

        enum_types[0] = PEXExtETTMTexelSampleMethod ;
        break ;
    case 11:
        _ibmpex_stderr_print( "***********************************************\n");
        _ibmpex_stderr_print( " Test 11    Texture Mapping Boundary Condition \n") ;
        _ibmpex_stderr_print( "***********************************************\n\n");

        enum_types[0] = PEXExtETTMBoundaryCondition ;
        break ;
    case 12:
        _ibmpex_stderr_print( "***********************************************\n");
        _ibmpex_stderr_print( " Test 12    Texture Mapping Clamp Color Source \n");
        _ibmpex_stderr_print( "***********************************************\n\n");

        enum_types[0] = PEXExtETTMClampColorSource ;
        break ;
    case 13:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 13    Texture Mapping Domain \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETTMDomain ;
        break ;
    case 14:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 14    Texel Type             \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETTexelType ;
        break ;
    case 15:
        _ibmpex_stderr_print( "******************************************\n");
        _ibmpex_stderr_print( " Test 15    Texture Mapping Resource Hint \n");
        _ibmpex_stderr_print( "******************************************\n\n");

        enum_types[0] = PEXExtETTMResourceHint ;
        break ;
    case 16:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 16    Texture Mapping Type   \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETTMType ;
        break ;
    case 17:
        _ibmpex_stderr_print( "***************************************************\n");
        _ibmpex_stderr_print( " Test 17    Texture Mapping Parametrization Method \n");
        _ibmpex_stderr_print( "***************************************************\n\n");

        enum_types[0] = PEXExtETTMParameterizationMethod ;
        break ;
    case 18:
        _ibmpex_stderr_print( "***************************************************\n");
        _ibmpex_stderr_print( " Test 18    Texture Mapping Perspective Correction \n");
        _ibmpex_stderr_print( "***************************************************\n\n");

        enum_types[0] = PEXExtETTMPerspectiveCorrection ;
        break ;
    case 19:
        _ibmpex_stderr_print( "*********************************************\n");
        _ibmpex_stderr_print( " Test 19    Texture Mapping Sample Frequency \n");
        _ibmpex_stderr_print( "*********************************************\n\n");

        enum_types[0] = PEXExtETTMSampleFrequency ;
        break ;
        break ;
    case 20:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 20    Primitive Anti-Alias Mode  \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETPrimitiveAAMode ;
        break ;
    case 21:
        _ibmpex_stderr_print( "***************************************************\n");
        _ibmpex_stderr_print( " Test 21    Primitive Anti-Alias Blend Operations  \n");
        _ibmpex_stderr_print( "***************************************************\n\n");

        enum_types[0] = PEXExtETPrimitiveAABlendOp ;
        break ;
    case 22:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 22    Line Cap Styles  \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETLineCapStyle ;
        break ;
    case 23:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 23    Line Join Styles  \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXExtETLineJoinStyle ;
        break ;
    case 24:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 24    Escape (New and Old) \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXETEscape ;
        break ;
    case 25:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 25    Line Type (New and Old)  \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXETLineType ;
        break ;
    case 26:
        _ibmpex_stderr_print( "***************************************\n");
        _ibmpex_stderr_print( " Test 26    Hatch Style (New and Old)  \n");
        _ibmpex_stderr_print( "***************************************\n\n");

        enum_types[0] = PEXETHatchStyle ;
        break ;
    case 27:
        _ibmpex_stderr_print( "******************************************\n");
        _ibmpex_stderr_print( " Test 27    Interior Style (New and Old)  \n");
        _ibmpex_stderr_print( "******************************************\n\n");

        enum_types[0] = PEXETInteriorStyle ;
        break ;
    case 28:
        _ibmpex_stderr_print( "*********************************************\n");
        _ibmpex_stderr_print( " Test 28    Existing 5.1 Enumeration Types  \n");
        _ibmpex_stderr_print( "               (in one big lump!)           \n");
        _ibmpex_stderr_print( "*********************************************\n\n");

        enum_types[0] = PEXETATextStyle ;
        enum_types[1] = PEXETColorApproxModel ;
        enum_types[2] = PEXETColorApproxType ;
        enum_types[3] = PEXETColorType ;
        enum_types[4] = PEXETCurveApproxMethod ;
        enum_types[5] = PEXETDisplayUpdateMode ;
        enum_types[6] = PEXETFloatFormat ;
        enum_types[7] = PEXETEscape ;
        enum_types[8] = PEXETGDP2D ;
        enum_types[9] = PEXETGDP ;
        enum_types[10] = PEXETGSE ;
        enum_types[11] = PEXETHatchStyle ;
        enum_types[12] = PEXETHLHSRMode ;
        enum_types[13] = PEXETInteriorStyle ;
        enum_types[14] = PEXETLightType ;
        enum_types[15] = PEXETLineType ;
        enum_types[16] = PEXETMarkerType ;
        enum_types[17] = PEXETModelClipOperator ;
        enum_types[18] = PEXETParaSurfCharacteristics ;
        enum_types[19] = PEXETPickAllMethod ;
        enum_types[20] = PEXETPickDeviceType ;
        enum_types[21] = PEXETPickOneMethod ;
        enum_types[22] = PEXETPolylineInterpMethod ;
        enum_types[23] = PEXETPromptEchoType ;
        enum_types[24] = PEXETReflectionModel ;
        enum_types[25] = PEXETRenderingColorModel ;
        enum_types[26] = PEXETSurfaceApproxMethod ;
        enum_types[27] = PEXETSurfaceEdgeType ;
        enum_types[28] = PEXETSurfaceInterpMethod ;
        enum_types[29] = PEXETTrimCurveApproxMethod ;
        break ;
    }

    /* Gather and print the results */
    item_mask = PEXETIndex | PEXETMnemonic ;
    if (cur_image != 28) {
        status = PEXGetEnumTypeInfo(dpy, local_win, 1, enum_types, item_mask,
                                    &num_values, &values) ;
        for (i=0; i < num_values[0]; i++) {
          _ibmpex_stderr_print("%s = %x\n", values[i].descriptor, 
                               (unsigned short) values[i].index);
        }
        PEXFreeEnumInfo(1, num_values, values) ;
    }
    else {
        status = PEXGetEnumTypeInfo(dpy, local_win, 30, enum_types, item_mask,
                                    &num_values, &values) ;
        count = 0 ;
        for (j=0; j < 30; j++) {
          switch (j) {
            case 0:
              _ibmpex_stderr_print("ATextStyle\n");
              break ;
            case 1:
              _ibmpex_stderr_print("ColorApproxModel\n");
              break ;
            case 2:
              _ibmpex_stderr_print("ColorApproxType\n");
              break ;
            case 3:
              _ibmpex_stderr_print("ColorType\n");
              break ;
            case 4:
              _ibmpex_stderr_print("CurveApproxMethod\n");
              break ;
            case 5:
              _ibmpex_stderr_print("DisplayUpdateMode\n");
              break ;
            case 6:
              _ibmpex_stderr_print("FloatFormat\n");
              break ;
            case 7:
              _ibmpex_stderr_print("Escape\n");
              break ;
            case 8:
              _ibmpex_stderr_print("GDP2D\n");
              break ;
            case 9:
              _ibmpex_stderr_print("GDP\n");
              break ;
            case 10:
              _ibmpex_stderr_print("GSE\n");
              break ;
            case 11:
              _ibmpex_stderr_print("HatchStyle\n");
              break ;
            case 12:
              _ibmpex_stderr_print("HLHSRMode\n");
              break ;
            case 13:
              _ibmpex_stderr_print("InteriorStyle\n");
              break ;
            case 14:
              _ibmpex_stderr_print("LightType\n");
              break ;
            case 15:
              _ibmpex_stderr_print("LineType\n");
              break ;
            case 16:
              _ibmpex_stderr_print("MarkerType\n");
              break ;
            case 17:
              _ibmpex_stderr_print("ModelClipOperator\n");
              break ;
            case 18:
              _ibmpex_stderr_print("ParaSurfCharacteristics\n");
              break ;
            case 19:
              _ibmpex_stderr_print("PickAllMethod\n");
              break ;
            case 20:
              _ibmpex_stderr_print("PickDeviceType\n");
              break ;
            case 21:
              _ibmpex_stderr_print("PickOneMethod\n");
              break ;
            case 22:
              _ibmpex_stderr_print("PolylineInterpMethod\n");
              break ;
            case 23:
              _ibmpex_stderr_print("PromptEchoType\n");
              break ;
            case 24:
              _ibmpex_stderr_print("ReflectionModel\n");
              break ;
            case 25:
              _ibmpex_stderr_print("RenderingColorModel\n");
              break ;
            case 26:
              _ibmpex_stderr_print("SurfaceApproxMethod\n");
              break ;
            case 27:
              _ibmpex_stderr_print("SurfaceEdgeType\n");
              break ;
            case 28:
              _ibmpex_stderr_print("SurfaceInterpMethod\n");
              break ;
            case 29:
              _ibmpex_stderr_print("TrimCurveApproxMethod\n");
              break ;
            default :
              _ibmpex_stderr_print("Enum #%d\n",j);
              break ;
          }
          _ibmpex_stderr_print("--------------------------\n");
          for (i=0; i < num_values[j]; i++) {
            _ibmpex_stderr_print("%s = %x\n", values[count].descriptor,
                                 (unsigned short) values[count].index);
            count += 1 ;
          }
          _ibmpex_stderr_print("\n");
        }
        PEXFreeEnumInfo(30, num_values, values) ;
    }
    _ibmpex_stderr_print("\n");

}

void testproc(Display *dpy, Window window, int cur_image)
    {
    char * file_name[80] ;
    
    sprintf(file_name,"enum_%d.stderr",cur_image) ; 
    file_testproc(file_name, "enum");
    }
