/******************************************************************************/
/*  (C) COPYRIGHT International Business Machines Corp. 1993                  */
/*                            All Rights Reserved                             */
/*                                                                            */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THIS MATERIAL        */
/*  "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,        */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND FITNESS FOR A PARTICULAR PURPOSE.                                     */
/*                                                                            */
/******************************************************************************/
#include <X11/PEX5/PEXlib.h>
#include <misc.h>

#define IMM_MODE_SPT(info) \
	(((info)->subset_info & 0xFFFF) == PEXCompleteImplementation \
		|| (info)->subset_info & PEXImmediateMode)

#define STR_MODE_SPT(info) \
	(((info)->subset_info & 0xFFFF) == PEXCompleteImplementation \
		|| (info)->subset_info & PEXStructureMode)

/****************************************************************************
 *   No primitives drawn in this test                                       *
 ***************************************************************************/
void draw_model(Display          *dpy,
               XID              resourceID,
               PEXOCRequestType req_type)
{
    PEXExtensionInfo	*pexinfo;
 
    pexinfo = PEXGetExtensionInfo(dpy);

    if IMM_MODE_SPT(pexinfo) 
       _ibmpex_stderr_print("Immediate Mode is supported!\n");
    else        
       _ibmpex_stderr_print("Error: Immediate Mode is not supported!\n");
    if STR_MODE_SPT(pexinfo) 
       _ibmpex_stderr_print("Structure Mode is supported!\n");
    else        
       _ibmpex_stderr_print("Error: Structure Mode is not supported!\n");
    
}

/****************************************************************************
 *  Sets the test parameters                                                *
 ***************************************************************************/
void inquire_test_params(char *test_name,
                         int  *num_images,
                         int  *supported_modes,
                         char *win_title)


{
    strcpy(test_name, "subsets");
    *num_images = 1;
    *supported_modes = IMM_MODE | STR_MODE;

    strcpy(win_title, "PEX Subset Support Test");
}


/****************************************************************************
 *  This routine is used to do miscellaneous things like setting some       *
 *  renderer attributess, Viewing etc if needed.                            *
 ***************************************************************************/
void misc_setup(Display *dpy, Window window, PEXRenderer renderer,
                int cur_image)
{
}

/****************************************************************************
 *  This routine calls the function which does the actual test              *
 ***************************************************************************/
void execute_test(Display *dpy, XID resourceID,
               PEXOCRequestType req_type, int cur_image)
{

    describe_test( "\n" );
    describe_test( " IBM Subset Verification Test:\n");
    describe_test( "\n" );
    describe_test( " This test will perform the following:\n");
    describe_test( "\n"); 
    describe_test( "     1) Check for support of the Immediate Mode Subset\n");
    describe_test( "     2) Check for support of the Structure Mode Subset\n");
    describe_test( "\n"); 

    draw_model(dpy, resourceID, req_type);

}

void testproc(Display *dpy, Window window, int cur_image)
{
    image_testproc("subsets", "PEX Subset Verification Test", img_desc,
                    dpy,window, 0, 0,
                    glob_window_width, glob_window_height);
}

